#define _GNU_SOURCE 1

#include <pthread.h>

#include <stdlib.h>

#include <dlfcn.h>

static int initializing = 0;
static int (*real_pthread_mutex_lock)(pthread_mutex_t *) = 0;

int pthread_mutex_lock(pthread_mutex_t *mutex)
{
        if(initializing)
                abort(); // Recursive call

        if(!real_pthread_mutex_lock)
        {
                initializing = 1;

                real_pthread_mutex_lock = dlsym(RTLD_NEXT, "pthread_mutex_lock");

                initializing = 0;
        }

        real_pthread_mutex_lock(mutex);
}
